﻿// Refresh from URL: http://sitecoredemo/sitecore/shell/Applications/CompiledDomainModel/CodeGenerator.aspx?direct=DomainModelGenerator
/*
 * This file was generated by the CompiledDomainModel Sitecore module (version 0.5.5.0).
 * User 'sitecore\admin' generated this file.
 * The version of the domain model (auto-incremented) is 4.
 * Please do not modify anything in this file, as any modifications will be lost after re-generating it.
 * Instead, you can extend the functionality of the classes and interfaces in this file using partial classes, inheritance or extension methods.
 * 
 * Visit http://trac.sitecore.net/CompiledDomainModel/wiki if you need more information.
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using Sitecore.Data;
using Sitecore.Data.Items;
using Sitecore.Data.Fields;
using Sitecore.Diagnostics;
using CompiledDomainModel.Attributes;

namespace UnitTestingDemo.Website.Domain
{
    /// <summary>
    /// Wrapper class for Sitecore items. Provides typed access to related items.
    /// </summary>
    [VersionAttribute("0.5.5.0", 4)]
    public partial class ItemWrapper : IItemWrapper, INotifyPropertyChanging, INotifyPropertyChanged
    {
        /// <summary>
        /// Map template IDs to a corresponding type in the domain model.
        /// </summary>
        protected static readonly IDictionary<ID, Type> TypeMappings = new Dictionary<ID, Type>
        {
          { UnitTestingDemo.Website.Domain.DomainModel.Page.TEMPLATE_ID, typeof(UnitTestingDemo.Website.Domain.DomainModel.Page) },
          { UnitTestingDemo.Website.Domain.DomainModel.RecipeManagerPage.TEMPLATE_ID, typeof(UnitTestingDemo.Website.Domain.DomainModel.RecipeManagerPage) },
          { UnitTestingDemo.Website.Domain.DomainModel.Recipe.TEMPLATE_ID, typeof(UnitTestingDemo.Website.Domain.DomainModel.Recipe) },
          { UnitTestingDemo.Website.Domain.DomainModel.RecipeCategory.TEMPLATE_ID, typeof(UnitTestingDemo.Website.Domain.DomainModel.RecipeCategory) },
          { UnitTestingDemo.Website.Domain.DomainModel.Ingredient.TEMPLATE_ID, typeof(UnitTestingDemo.Website.Domain.DomainModel.Ingredient) },
          { UnitTestingDemo.Website.Domain.DomainModel.IngredientUse.TEMPLATE_ID, typeof(UnitTestingDemo.Website.Domain.DomainModel.IngredientUse) },
        };

        /// <summary>
        /// Map contributing template IDs to a corresponding interface.
        /// If a domain model class implements the interface, it means that the template inherits this contributing template.
        /// </summary>
        protected static readonly IDictionary<ID, Type> ContributingTypeMappings = new Dictionary<ID, Type>
        {
        };

        /// <summary>
        /// Determines what templates (within scope of the domain model configuration) a certain type supports.
        /// </summary>
        /// <typeparam name="T">The type to find valid template IDs for.</typeparam>
        /// <returns>A list of template IDs that are valid for the type.</returns>
        protected static IEnumerable<ID> GetValidTemplateIdsForType<T>() where T : IItemWrapper
        {
            return TypeMappings.Concat(ContributingTypeMappings).Where(typeMapping => typeof(T).IsAssignableFrom(typeMapping.Value)).Select(typeMapping => typeMapping.Key);
        }

        /// <summary>
        /// Event that is fired before the value of a field is changed through the domain model.
        /// </summary>
        public event PropertyChangingEventHandler PropertyChanging;

        /// <summary>
        /// Event that is fired after the value of a field is changed through the domain model.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        /// <summary>
        /// The Sitecore item that is wrapped. It must always be passed through a constructor.
        /// </summary>
        public Item Item { get; private set; }

        /// <summary>
        /// Create a wrapper for the passed in item.
        /// </summary>
        /// <param name="item">The Sitecore item to create a wrapper for.</param>
        public ItemWrapper(Item item)
        {
            Assert.IsNotNull(item, string.Format("No item was passed to create a new '{0}' object", GetType().ToString()));
            Item = item;
        }

        /// <summary>
        /// Use this method to wrap any Sitecore item. If the item can be used in a typed way, then you will get an object of that type.
        /// </summary>
        /// <param name="item">The Sitecore item to create a typed wrapper for.</param>
        /// <returns>An item wrapper (typed, if possible).</returns>
        public static ItemWrapper CreateTypedWrapper(Item item)
        {
            return (item != null && TypeMappings.ContainsKey(item.TemplateID))
                ? TypeMappings[item.TemplateID].InvokeMember("ctor", System.Reflection.BindingFlags.CreateInstance, null, null, new object[] { item }) as ItemWrapper
                : new ItemWrapper(item);
        }

        /// <summary>
        /// Get a typed wrapper for the parent of the item.
        /// </summary>
        public virtual IItemWrapper Parent
        {
            get
            {
                return Item.Parent != null ? CreateTypedWrapper(Item.Parent) : null;
            }
        }

        /// <summary>
        /// Get a list of typed wrappers for all the child items.
        /// </summary>
        public virtual IEnumerable<IItemWrapper> Children
        {
            get
            {
                if (!Item.HasChildren)
                {
                    return null;
                }
                IEnumerable<IItemWrapper> childObjects = Item.Children.InnerChildren.Select(child => CreateTypedWrapper(child)).Where(child => child != null).OfType<IItemWrapper>();
                return childObjects.Count() > 0 ? childObjects : null;
            }
        }

        /// <summary>
        /// Get a list of typed wrappers for all the child items that can be wrapped with the specified type.
        /// </summary>
        /// <typeparam name="T">The type to filter the children with.</typeparam>
        /// <returns>The list of children of the specified type.</returns>
        public virtual IEnumerable<T> GetChildren<T>() where T : IItemWrapper
        {
            IEnumerable<IItemWrapper> childObjects = Children;
            IEnumerable<T> typedChildren = childObjects != null ? childObjects.OfType<T>() : null;
            return typedChildren != null && typedChildren.Count() > 0 ? typedChildren : null;
        }

        /// <summary>
        /// Iterates all the item's ancestors and returns the first one that is of the specified type.
        /// </summary>
        /// <typeparam name="T">The type of ancestor that is needed.</typeparam>
        /// <returns>A typed wrapper for the first ancestor of the specified type.</returns>
        public virtual T GetFirstAncestor<T>() where T : class, IItemWrapper
        {
            IItemWrapper parent = Parent;
            if (parent == null)
            {
                return null;
            }
            else if (parent as T != null)
            {
                return parent as T;
            }
            return parent.GetFirstAncestor<T>();
        }

        /// <summary>
        /// Returns a list of all the item's descendants of the specified type.
        /// Warning: only use this if you're certain it will not return too much; could cause performance issues.
        /// </summary>
        /// <typeparam name="T">Type to filter the result with.</typeparam>
        /// <returns>The list of descendants of the specified type.</returns>
        public virtual IEnumerable<IItemWrapper> Descendants
        {
            get
            {
                Item[] descendantItems = Item.Axes.GetDescendants();
                if (descendantItems == null || descendantItems.Length == 0)
                {
                    return null;
                }
                IEnumerable<IItemWrapper> descendantObjects = descendantItems.Select(descendant => CreateTypedWrapper(descendant)).Where(descendant => descendant != null).OfType<IItemWrapper>();
                return descendantObjects.Count() > 0 ? descendantObjects : null;
            }
        }

        /// <summary>
        /// Returns a list of all the item's descendants of the specified type.
        /// Warning: only use this if you're certain it will not return too much; could cause performance issues.
        /// </summary>
        /// <typeparam name="T">Type to filter the result with.</typeparam>
        /// <returns>The list of descendants of the specified type.</returns>
        public virtual IEnumerable<T> GetDescendants<T>() where T : IItemWrapper
        {
            IEnumerable<IItemWrapper> descendants = Descendants;
            if (descendants == null || descendants.Count() == 0)
            {
                return null;
            }
            IEnumerable<T> descendantObjects = descendants.OfType<T>();
            return descendantObjects.Count() > 0 ? descendantObjects : null;
        }

        /// <summary>
        /// Gets a list of all the items that refer to this item.
        /// Warning: this only works if the link database is enabled.
        /// Visit http://sdn.sitecore.net/SDN5/Articles/Administration/Links%20Database.aspx for more information.
        /// </summary>
        public virtual IEnumerable<IItemWrapper> Referrers
        {
            get
            {
                Sitecore.Links.ItemLink[] referrers = Sitecore.Globals.LinkDatabase.GetReferrers(Item);
                if (referrers == null || referrers.Length == 0)
                {
                    return null;
                }
                IEnumerable<IItemWrapper> referrerObjects = referrers.Select(referrer => CreateTypedWrapper(referrer.GetSourceItem())).Where(referrer => referrer != null).OfType<IItemWrapper>();
                return referrerObjects.Count() > 0 ? referrerObjects : null;
            }
        }

        /// <summary>
        /// Gets a list of all the items that refer to this item and that are of the specified type.
        /// Warning: this only works if the link database is enabled.
        /// Visit http://sdn.sitecore.net/SDN5/Articles/Administration/Links%20Database.aspx for more information.
        /// </summary>
        /// <typeparam name="T">Type to filter the result with.</typeparam>
        /// <returns>A list of all the items that refer to this item and that are of the specified type.</returns>
        public virtual IEnumerable<T> GetReferrers<T>() where T : IItemWrapper
        {
            IEnumerable<IItemWrapper> referrerObjects = Referrers;
            IEnumerable<T> typedReferrerObjects = referrerObjects != null ? referrerObjects.OfType<T>() : null;
            return typedReferrerObjects != null && typedReferrerObjects.Count() > 0 ? typedReferrerObjects : null;
        }

        /// <summary>
        /// Checks to see if the wrappers wrap the same item (compares by id).
        /// </summary>
        /// <param name="obj">The object to compare to.</param>
        /// <returns>True if the item ID's are the same.</returns>
        public override bool Equals(object obj)
        {
            if (obj as ItemWrapper == null)
            {
                return false;
            }
            return Object.Equals(Item.ID, ((ItemWrapper)obj).Item.ID)
                && Object.Equals(Item.Version.Number, ((ItemWrapper)obj).Item.Version.Number)
                && Object.Equals(Item.Language, ((ItemWrapper)obj).Item.Language);
        }

        /// <summary>
        /// Creates a hashcode (for example, for use in a hashset).
        /// </summary>
        /// <returns>A unique hashcode for the object.</returns>
        public override int GetHashCode()
        {
            return ((Item.ID.GetHashCode() * 13) + 2)
                * ((Item.Version.Number.GetHashCode() * 23) + 8)
                * ((Item.Language.GetHashCode() * 97) + 12);
        }

        /// <summary>
        /// Can be used to signal event listeners that a property that is about to change.
        /// </summary>
        /// <param name="propertyName">The name of the property that is about to change.</param>
        protected virtual void RaisePropertyChanging(string propertyName)
        {
            if (PropertyChanging != null)
            {
                PropertyChanging(this, new PropertyChangingEventArgs(propertyName));
            }
        }

        /// <summary>
        /// Can be used to signal event listeners that a property has just changed.
        /// </summary>
        /// <param name="propertyName">The name of the property that has just changed.</param>
        protected virtual void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        /// <summary>
        /// Get a Sitecore custom field by ID or fieldname (fallback).
        /// </summary>
        /// <typeparam name="T">The type of the field.</typeparam>
        /// <param name="fieldId">The Sitecore ID of the field.</param>
        /// <param name="fieldName">The name of the field.</param>
        /// <returns>The custom field object.</returns>
        protected virtual T GetField<T>(ID fieldId, string fieldName) where T : CustomField
        {
            return FieldTypeManager.GetField(GetField(fieldId, fieldName)) as T;
        }

        /// <summary>
        /// Get a Sitecore field by ID or fieldname (fallback).
        /// </summary>
        /// <param name="fieldId">The Sitecore ID of the field.</param>
        /// <param name="fieldName">The name of the field.</param>
        /// <returns>The field object.</returns>
        protected virtual Field GetField(ID fieldId, string fieldName)
        {
            return Item.Fields[fieldId] != null ? Item.Fields[fieldId] : Item.Fields[fieldName];
        }

        /// <summary>
        /// Override this method if you need a different strategy of resolving links within the domain model.
        /// </summary>
        /// <param name="link">The link field that needs to be resolved.</param>
        /// <returns>A string that represents the resolved link.</returns>
        protected virtual string ResolveLink(LinkField link)
        {
            return link.IsInternal || link.IsMediaLink
                ? ResolveLink(link.TargetItem)
                : link.Url;
        }

        /// <summary>
        /// Override this method if you need a different strategy of resolving links within the domain model.
        /// </summary>
        /// <param name="item">The item for which to resolve a link.</param>
        /// <returns>A string that represents the resolved link.</returns>
        protected virtual string ResolveLink(Item item)
        {
            return item != null ? Sitecore.Links.LinkManager.GetItemUrl(item) : null;
        }
    }

    /// <summary>
    /// The base class for all domain objects. Objects of this type can only be created for templates that are configured in the CompiledDomainModel configuration.
    /// </summary>
    public partial class DomainObjectBase : ItemWrapper
    {

        protected DomainObjectBase(Item item)
            : base(item)
        {
            Assert.IsTrue(ItemWrapper.TypeMappings.ContainsKey(item.TemplateID), string.Format("Tried to create a '{0}', but there is no domain object specified for template '{1}'", this.GetType().Name, item.TemplateName));
            Assert.IsTrue(this.GetType().IsAssignableFrom(ItemWrapper.TypeMappings[item.TemplateID]), string.Format("Tried to create a '{0}', but the template '{1}' is not valid for that type", this.GetType().Name, item.TemplateName));
        }
    }

    /// <summary>
    /// Interface for all wrappers and contributing templates.
    /// </summary>
    public partial interface IItemWrapper : CompiledDomainModel.Core.IItemWrapperCore
    {
        IItemWrapper Parent { get; }
        IEnumerable<IItemWrapper> Children { get; }
        IEnumerable<T> GetChildren<T>() where T : IItemWrapper;
        T GetFirstAncestor<T>() where T : class, IItemWrapper;
        IEnumerable<IItemWrapper> Descendants { get; }
        IEnumerable<T> GetDescendants<T>() where T : IItemWrapper;
        IEnumerable<IItemWrapper> Referrers { get; }
        IEnumerable<T> GetReferrers<T>() where T : IItemWrapper;
    }

    /// <summary>
    /// Marker interface for all contributing templates (templates that are not used as domain model classes, but that are implemented by domain model classes).
    /// </summary>
    public partial interface IContributingTemplate : IItemWrapper
    {
    }

}

// Domain objects for set "DomainModel"
namespace UnitTestingDemo.Website.Domain.DomainModel
{

    /// <summary>
    /// Typed wrapper class for items with template Page.
    /// </summary>
    [DomainObjectAttribute("{B4A00613-9704-4CDF-B8FC-5B7CEB70599F}", "Page", new string[] { "master" })]
    public partial class Page : DomainObjectBase
    {
        public const string TEMPLATE_NAME = "Page";
        public static readonly ID TEMPLATE_ID = ID.Parse("{B4A00613-9704-4CDF-B8FC-5B7CEB70599F}");

        public Page(Item item)
            : base(item)
        {
        }

        #region Page

        [DomainObjectFieldAttribute("{768FA795-1E10-4A2B-B5CB-6AE124848D36}", "Title", "Single-Line Text")]
        public const string FIELD_TITLE = "Title";

        [DomainObjectFieldAttribute("{F7B0DD38-C0D2-4C75-816C-3ED55B791B6B}", "Text content", "Rich Text")]
        public const string FIELD_TEXT_CONTENT = "Text content";

        public string Title
        {
            get
            {
                return GetField(ID.Parse("{768FA795-1E10-4A2B-B5CB-6AE124848D36}"), "Title").Value;
            }
            set
            {
                Field field = GetField(ID.Parse("{768FA795-1E10-4A2B-B5CB-6AE124848D36}"), "Title");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("Title");
                field.Value = value;
                RaisePropertyChanged("Title");
            }
        }

        public string TextContent
        {
            get
            {
                return GetField(ID.Parse("{F7B0DD38-C0D2-4C75-816C-3ED55B791B6B}"), "Text content").Value;
            }
            set
            {
                Field field = GetField(ID.Parse("{F7B0DD38-C0D2-4C75-816C-3ED55B791B6B}"), "Text content");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("TextContent");
                field.Value = value;
                RaisePropertyChanged("TextContent");
            }
        }

        #endregion

    }

    /// <summary>
    /// Typed wrapper class for items with template RecipeManagerPage.
    /// </summary>
    [DomainObjectAttribute("{78685355-DC03-4ACA-925D-24F3ABE2DDA5}", "RecipeManagerPage", new string[] { "master" })]
    public partial class RecipeManagerPage : UnitTestingDemo.Website.Domain.DomainModel.Page
    {
        public new const string TEMPLATE_NAME = "RecipeManagerPage";
        public new static readonly ID TEMPLATE_ID = ID.Parse("{78685355-DC03-4ACA-925D-24F3ABE2DDA5}");

        public RecipeManagerPage(Item item)
            : base(item)
        {
        }

    }

    /// <summary>
    /// Typed wrapper class for items with template Recipe.
    /// </summary>
    [DomainObjectAttribute("{D353FD44-3E71-4408-9114-55E73FD9E0BB}", "Recipe", new string[] { "master" })]
    public partial class Recipe : UnitTestingDemo.Website.Domain.DomainModel.Page
    {
        public new const string TEMPLATE_NAME = "Recipe";
        public new static readonly ID TEMPLATE_ID = ID.Parse("{D353FD44-3E71-4408-9114-55E73FD9E0BB}");

        public Recipe(Item item)
            : base(item)
        {
        }

        #region Recipe

        [DomainObjectFieldAttribute("{958A0853-C9BE-4415-8522-84D887F14891}", "Categories", "Treelist")]
        public const string FIELD_CATEGORIES = "Categories";

        public IEnumerable<ItemWrapper> Categories
        {
            get
            {
                Item[] targetItems = GetField<MultilistField>(ID.Parse("{958A0853-C9BE-4415-8522-84D887F14891}"), "Categories").GetItems();
                IEnumerable<ItemWrapper> targetObjects = targetItems != null
                    ? targetItems.Select(targetItem => ItemWrapper.CreateTypedWrapper(targetItem)).Where(targetItem => targetItem != null)
                    : null;
                return targetObjects != null && targetObjects.Count() > 0 ? targetObjects : null;
            }
        }

        public IEnumerable<T> GetCategories<T>() where T : ItemWrapper
        {
            IEnumerable<ItemWrapper> targetObjects = Categories;
            IEnumerable<T> typedObjects = targetObjects != null ? targetObjects.OfType<T>() : null;
            return typedObjects != null ? typedObjects : null;
        }

        #endregion

    }

    /// <summary>
    /// Typed wrapper class for items with template Recipe category.
    /// </summary>
    [DomainObjectAttribute("{9FFE48CB-0F28-44AC-8093-7A54A0FD871B}", "Recipe category", new string[] { "master" })]
    public partial class RecipeCategory : DomainObjectBase
    {
        public const string TEMPLATE_NAME = "Recipe category";
        public static readonly ID TEMPLATE_ID = ID.Parse("{9FFE48CB-0F28-44AC-8093-7A54A0FD871B}");

        public RecipeCategory(Item item)
            : base(item)
        {
        }

        #region Recipe category

        [DomainObjectFieldAttribute("{25858A62-6365-485E-8DCF-A9F74F1AD95F}", "Category name", "Single-Line Text")]
        public const string FIELD_CATEGORY_NAME = "Category name";

        public string CategoryName
        {
            get
            {
                return GetField(ID.Parse("{25858A62-6365-485E-8DCF-A9F74F1AD95F}"), "Category name").Value;
            }
            set
            {
                Field field = GetField(ID.Parse("{25858A62-6365-485E-8DCF-A9F74F1AD95F}"), "Category name");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("CategoryName");
                field.Value = value;
                RaisePropertyChanged("CategoryName");
            }
        }

        #endregion

    }

    /// <summary>
    /// Typed wrapper class for items with template Ingredient.
    /// </summary>
    [DomainObjectAttribute("{71FF8CDD-76FD-4EDC-9CAD-1B22E0F3062E}", "Ingredient", new string[] { "master" })]
    public partial class Ingredient : DomainObjectBase
    {
        public const string TEMPLATE_NAME = "Ingredient";
        public static readonly ID TEMPLATE_ID = ID.Parse("{71FF8CDD-76FD-4EDC-9CAD-1B22E0F3062E}");

        public Ingredient(Item item)
            : base(item)
        {
        }

        #region Ingredient

        [DomainObjectFieldAttribute("{9C182C3B-3623-4DFA-BA8D-E7E9C144666D}", "Name", "Single-Line Text")]
        public const string FIELD_NAME = "Name";

        public string Name
        {
            get
            {
                return GetField(ID.Parse("{9C182C3B-3623-4DFA-BA8D-E7E9C144666D}"), "Name").Value;
            }
            set
            {
                Field field = GetField(ID.Parse("{9C182C3B-3623-4DFA-BA8D-E7E9C144666D}"), "Name");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("Name");
                field.Value = value;
                RaisePropertyChanged("Name");
            }
        }

        #endregion

    }

    /// <summary>
    /// Typed wrapper class for items with template Ingredient use.
    /// </summary>
    [DomainObjectAttribute("{E0807F7C-E158-4A60-8721-96303E5D817F}", "Ingredient use", new string[] { "master" })]
    public partial class IngredientUse : DomainObjectBase
    {
        public const string TEMPLATE_NAME = "Ingredient use";
        public static readonly ID TEMPLATE_ID = ID.Parse("{E0807F7C-E158-4A60-8721-96303E5D817F}");

        public IngredientUse(Item item)
            : base(item)
        {
        }

        #region Ingredient

        [DomainObjectFieldAttribute("{75244768-B236-4913-84CE-600929831CF1}", "Ingredient", "Internal Link")]
        public const string FIELD_INGREDIENT = "Ingredient";

        [DomainObjectFieldAttribute("{524F7188-E668-43A4-9FF4-D01D1A8C4F77}", "Quantity", "Single-Line Text")]
        public const string FIELD_QUANTITY = "Quantity";

        [DomainObjectFieldAttribute("{4BF78185-2856-40EE-8ED1-70F261A27DBF}", "Unit", "Single-Line Text")]
        public const string FIELD_UNIT = "Unit";

        public ItemWrapper Ingredient
        {
            get
            {
                Item item = GetField<InternalLinkField>(ID.Parse("{75244768-B236-4913-84CE-600929831CF1}"), "Ingredient").TargetItem;
                return item != null ? ItemWrapper.CreateTypedWrapper(item) : null;
            }
            set
            {
                InternalLinkField field = GetField<InternalLinkField>(ID.Parse("{75244768-B236-4913-84CE-600929831CF1}"), "Ingredient");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("Ingredient");
                field.Value = value.Item.ID.ToString();
                RaisePropertyChanged("Ingredient");
            }
        }

        public T GetIngredient<T>() where T : ItemWrapper
        {
            return Ingredient as T;
        }

        public string Quantity
        {
            get
            {
                return GetField(ID.Parse("{524F7188-E668-43A4-9FF4-D01D1A8C4F77}"), "Quantity").Value;
            }
            set
            {
                Field field = GetField(ID.Parse("{524F7188-E668-43A4-9FF4-D01D1A8C4F77}"), "Quantity");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("Quantity");
                field.Value = value;
                RaisePropertyChanged("Quantity");
            }
        }

        public string Unit
        {
            get
            {
                return GetField(ID.Parse("{4BF78185-2856-40EE-8ED1-70F261A27DBF}"), "Unit").Value;
            }
            set
            {
                Field field = GetField(ID.Parse("{4BF78185-2856-40EE-8ED1-70F261A27DBF}"), "Unit");
                if (Object.Equals(field.Value, value))
                {
                    return;
                }
                RaisePropertyChanging("Unit");
                field.Value = value;
                RaisePropertyChanged("Unit");
            }
        }

        #endregion

    }

    #region Contributing templates for set "DomainModel"

    #endregion
}

#region Fixed paths from set with name "Paths"

namespace UnitTestingDemo.Website.Domain.FixedPaths.Content.UnitTestingDemo.ReusableContent
{
    /// <summary>
    /// Access the item at /sitecore/content/UnitTestingDemo/Reusable content/Ingredients.
    /// The availability of the item is validated in the databases: master.
    /// </summary>
    [FixedPathAttribute("{AD28E445-5621-4E62-8D22-588B6D2E0DA2}", "/sitecore/content/UnitTestingDemo/Reusable content/Ingredients", new string[] { "master" })]
    public static partial class IngredientsFixed
    {

        public static ItemWrapper GetItemWrapper(Database database)
        {
            return new ItemWrapper(GetItem(database));
        }

        public static ItemWrapper ItemWrapper
        {
            get
            {
                return GetItemWrapper(Sitecore.Context.Database);
            }
        }

        public static ItemWrapper ItemWrapperFromMaster
        {
            get
            {
                return GetItemWrapper(Database.GetDatabase("master"));
            }
        }

        private static Item GetItem(Database database)
        {
            Item item = database.GetItem(ID.Parse("{AD28E445-5621-4E62-8D22-588B6D2E0DA2}"));
            if (item != null)
            {
                return "/sitecore/content/UnitTestingDemo/Reusable content/Ingredients".Equals(item.Paths.FullPath)
                    ? item
                    : (database.GetItem("/sitecore/content/UnitTestingDemo/Reusable content/Ingredients") ?? item);
            }
            else
            {
                return database.GetItem("/sitecore/content/UnitTestingDemo/Reusable content/Ingredients");
            }
        }
    }
}

namespace UnitTestingDemo.Website.Domain.FixedPaths.Content.UnitTestingDemo
{
    /// <summary>
    /// Access the item at /sitecore/content/UnitTestingDemo/Reusable content.
    /// The availability of the item is validated in the databases: master.
    /// </summary>
    [FixedPathAttribute("{0494A406-F234-4FCF-92BD-FFC389355CAB}", "/sitecore/content/UnitTestingDemo/Reusable content", new string[] { "master" })]
    public static partial class ReusableContentFixed
    {

        public static ItemWrapper GetItemWrapper(Database database)
        {
            return new ItemWrapper(GetItem(database));
        }

        public static ItemWrapper ItemWrapper
        {
            get
            {
                return GetItemWrapper(Sitecore.Context.Database);
            }
        }

        public static ItemWrapper ItemWrapperFromMaster
        {
            get
            {
                return GetItemWrapper(Database.GetDatabase("master"));
            }
        }

        private static Item GetItem(Database database)
        {
            Item item = database.GetItem(ID.Parse("{0494A406-F234-4FCF-92BD-FFC389355CAB}"));
            if (item != null)
            {
                return "/sitecore/content/UnitTestingDemo/Reusable content".Equals(item.Paths.FullPath)
                    ? item
                    : (database.GetItem("/sitecore/content/UnitTestingDemo/Reusable content") ?? item);
            }
            else
            {
                return database.GetItem("/sitecore/content/UnitTestingDemo/Reusable content");
            }
        }
    }
}

namespace UnitTestingDemo.Website.Domain.FixedPaths.Content
{
    /// <summary>
    /// Access the item at /sitecore/content/UnitTestingDemo.
    /// The availability of the item is validated in the databases: master.
    /// </summary>
    [FixedPathAttribute("{CE988803-3428-4541-A4D7-0D03D7506054}", "/sitecore/content/UnitTestingDemo", new string[] { "master" })]
    public static partial class UnitTestingDemoFixed
    {

        public static ItemWrapper GetItemWrapper(Database database)
        {
            return new ItemWrapper(GetItem(database));
        }

        public static ItemWrapper ItemWrapper
        {
            get
            {
                return GetItemWrapper(Sitecore.Context.Database);
            }
        }

        public static ItemWrapper ItemWrapperFromMaster
        {
            get
            {
                return GetItemWrapper(Database.GetDatabase("master"));
            }
        }

        private static Item GetItem(Database database)
        {
            Item item = database.GetItem(ID.Parse("{CE988803-3428-4541-A4D7-0D03D7506054}"));
            if (item != null)
            {
                return "/sitecore/content/UnitTestingDemo".Equals(item.Paths.FullPath)
                    ? item
                    : (database.GetItem("/sitecore/content/UnitTestingDemo") ?? item);
            }
            else
            {
                return database.GetItem("/sitecore/content/UnitTestingDemo");
            }
        }
    }
}

namespace UnitTestingDemo.Website.Domain.FixedPaths
{
    /// <summary>
    /// Access the item at /sitecore/content.
    /// The availability of the item is validated in the databases: master.
    /// </summary>
    [FixedPathAttribute("{0DE95AE4-41AB-4D01-9EB0-67441B7C2450}", "/sitecore/content", new string[] { "master" })]
    public static partial class ContentFixed
    {

        public static ItemWrapper GetItemWrapper(Database database)
        {
            return new ItemWrapper(GetItem(database));
        }

        public static ItemWrapper ItemWrapper
        {
            get
            {
                return GetItemWrapper(Sitecore.Context.Database);
            }
        }

        public static ItemWrapper ItemWrapperFromMaster
        {
            get
            {
                return GetItemWrapper(Database.GetDatabase("master"));
            }
        }

        private static Item GetItem(Database database)
        {
            Item item = database.GetItem(ID.Parse("{0DE95AE4-41AB-4D01-9EB0-67441B7C2450}"));
            if (item != null)
            {
                return "/sitecore/content".Equals(item.Paths.FullPath)
                    ? item
                    : (database.GetItem("/sitecore/content") ?? item);
            }
            else
            {
                return database.GetItem("/sitecore/content");
            }
        }
    }
}

namespace UnitTestingDemo.Website.Domain.FixedPaths.Content.UnitTestingDemo.ReusableContent
{
    /// <summary>
    /// Access the item at /sitecore/content/UnitTestingDemo/Reusable content/Recipe categories.
    /// The availability of the item is validated in the databases: master.
    /// </summary>
    [FixedPathAttribute("{EDBFFA86-DE32-408A-BEC9-397901A742CA}", "/sitecore/content/UnitTestingDemo/Reusable content/Recipe categories", new string[] { "master" })]
    public static partial class RecipeCategoriesFixed
    {

        public static ItemWrapper GetItemWrapper(Database database)
        {
            return new ItemWrapper(GetItem(database));
        }

        public static ItemWrapper ItemWrapper
        {
            get
            {
                return GetItemWrapper(Sitecore.Context.Database);
            }
        }

        public static ItemWrapper ItemWrapperFromMaster
        {
            get
            {
                return GetItemWrapper(Database.GetDatabase("master"));
            }
        }

        private static Item GetItem(Database database)
        {
            Item item = database.GetItem(ID.Parse("{EDBFFA86-DE32-408A-BEC9-397901A742CA}"));
            if (item != null)
            {
                return "/sitecore/content/UnitTestingDemo/Reusable content/Recipe categories".Equals(item.Paths.FullPath)
                    ? item
                    : (database.GetItem("/sitecore/content/UnitTestingDemo/Reusable content/Recipe categories") ?? item);
            }
            else
            {
                return database.GetItem("/sitecore/content/UnitTestingDemo/Reusable content/Recipe categories");
            }
        }
    }
}

#endregion

namespace UnitTestingDemo.Website.Domain.RelativeFixedPaths
{
    /// <summary>
    /// Base class for fixed paths that can be used relative to other items.
    /// </summary>
    public abstract partial class RelativeFixedPath
    {
        /// <summary>
        /// The Sitecore item for the relative path at this point.
        /// </summary>
        public Item RelativeFixedPathItem { get; private set; }

        /// <summary>
        /// Use this constructor to create a relative fixed path tree starting with the item that is passed.
        /// </summary>
        /// <param name="relativeFixedPathItem">The item to start the tree with</param>
        public RelativeFixedPath(Item relativeFixedPathItem)
        {
            RelativeFixedPathItem = relativeFixedPathItem;
        }

        /// <summary>
        /// Because relative fixed paths cannot be validated (except for the original structure), runtime validation can be done using this method.
        /// </summary>
        /// <returns>Messages for each failed validation, or null if everything is ok</returns>
        public abstract string[] GetValidationMessages();

        protected void Validate(List<string> validationMessages, string childName, RelativeFixedPath childRelativeFixedPath)
        {
            if (childRelativeFixedPath != null)
            {
                validationMessages.AddRange(childRelativeFixedPath.GetValidationMessages() ?? new string[0]);
            }
            else
            {
                validationMessages.Add(string.Format("Could not find a child item '{0}' for relative fixed path item '{1}'.", childName, RelativeFixedPathItem.Paths.FullPath));
            }
        }

        protected void ValidateType<T>(List<string> validationMessages, Item RelativeFixedPathItem) where T : IItemWrapper
        {
            if (!typeof(T).IsAssignableFrom(ItemWrapper.CreateTypedWrapper(RelativeFixedPathItem).GetType()))
            {
                validationMessages.Add(string.Format("The item {0} was expected to be a {1}, but it was a {2}", RelativeFixedPathItem.Paths.FullPath, typeof(T).Name, RelativeFixedPathItem.TemplateName));
            }
        }
    }
}

#region Relative fixed paths from set with name "Paths"

#endregion

